package tools.descartes.prisma.core;

import java.io.IOException;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.resource.Resource;

public interface ModelRepository {

	public SystemGlobalScope getSystemScope();

	public Scope getScope(String path);

	public void createFolders(Transaction transaction, String path);

	public Resource getOrCreateResource(Transaction transaction, String path);

	public Resource getResource(String path);
	
	public List<String> listResources(String path);

	public boolean exists(String path);

	public Transaction createTransaction();
	
	public Map<String, String> loadPropertiesFile(String path) throws IOException;

	public void storePropertiesFile(Transaction transaction, String path, Map<String, String> properties)
			throws IOException;

	public void waitForUpdate();

}
