package tools.descartes.prisma.core.templates.resourceconfiguration;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import edu.kit.ipd.descartes.mm.resourceconfiguration.ActiveResourceSpecification;
import edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationFactory;
import edu.kit.ipd.descartes.mm.resourceconfiguration.SchedulingPolicy;
import edu.kit.ipd.descartes.mm.resourcelandscape.Container;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage;
import tools.descartes.prisma.core.templates.ModelTemplate;
import tools.descartes.prisma.core.templates.core.NamedElementTemplate;
import tools.descartes.prisma.core.templates.resourcetype.ProcessingResourceTypeTemplate;

public class ActiveResourceSpecificationTemplate extends NamedElementTemplate<Container, ActiveResourceSpecification> {
	
	private final Map<String, ProcessingResourceSpecificationTemplate> processingResources = new HashMap<>();
	
	public ActiveResourceSpecificationTemplate(String name) {
		super(ResourcelandscapePackage.Literals.CONTAINER__CONFIG_SPEC, ActiveResourceSpecification.class, name);
	}
	
	public ProcessingResourceSpecificationTemplate defineProcessingResource(String name, ProcessingResourceTypeTemplate typeTemplate, SchedulingPolicy policy, int units) {
		ProcessingResourceSpecificationTemplate template = processingResources.get(name);
		if (template == null) {
			template = new ProcessingResourceSpecificationTemplate(name, typeTemplate, policy, units);
			processingResources.put(name, template);
		}
		return template;
	}
	
	@Override
	public List<? extends ModelTemplate<? super ActiveResourceSpecification, ?>> getChildCommands() {
		return new ArrayList<>(processingResources.values());
	}

	@Override
	protected ActiveResourceSpecification create(Container parent) {
		ActiveResourceSpecification spec = ResourceconfigurationFactory.eINSTANCE.createActiveResourceSpecification();
		spec.setName(getName());
		return spec;
	}
	
	

}
