package tools.descartes.prisma.core.templates.resourcelandscape;

import java.util.LinkedList;
import java.util.List;

import edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapeFactory;
import tools.descartes.prisma.core.templates.ModelTemplate;

public class DistributedDataCenterTemplate extends ModelTemplate<DistributedDataCenter, DistributedDataCenter> {
	
	private final List<DataCenterTemplate> dataCenters = new LinkedList<>();

	public DistributedDataCenterTemplate() {
		super(null, DistributedDataCenter.class);
	}
	
	public DistributedDataCenterTemplate add(DataCenterTemplate dataCenter) {
		dataCenters.add(dataCenter);
		return this;
	}
	
	@Override
	public DistributedDataCenter get(DistributedDataCenter parent) {
		DistributedDataCenter ddc = find(getContext().getResourceLandscapeResource().getContents());
		if (ddc == null) {
			ddc = create(null);
			getContext().getResourceLandscapeResource().getContents().add(ddc);
		}
		return ddc;
	}
	

	@Override
	public List<? extends ModelTemplate<? super DistributedDataCenter, ?>> getChildCommands() {
		return dataCenters;
	}


	@Override
	public boolean matches(DistributedDataCenter object) {
		return object.getName().equals(getContext().getApplicationName());
	}


	@Override
	protected DistributedDataCenter create(DistributedDataCenter parent) {
		DistributedDataCenter ddc = ResourcelandscapeFactory.eINSTANCE.createDistributedDataCenter();
		ddc.setName(getContext().getApplicationName());
		return ddc;
	}

}
