package tools.descartes.prisma.core.templates.resourcetype;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import edu.kit.ipd.descartes.mm.resourcetype.ResourceTypeRepository;
import edu.kit.ipd.descartes.mm.resourcetype.ResourcetypeFactory;
import tools.descartes.prisma.core.templates.ModelTemplate;

public class ResourceTypeRepositoryTemplate extends ModelTemplate<ResourceTypeRepository, ResourceTypeRepository> {
	
	private final Map<String, ProcessingResourceTypeTemplate> processingResources = new HashMap<>();

	public ResourceTypeRepositoryTemplate() {
		super(null, ResourceTypeRepository.class);
	}
	
	@Override
	public ResourceTypeRepository get(ResourceTypeRepository parent) {
		ResourceTypeRepository resourcetypes = find(getContext().getResourceTypesResource().getContents());
		if (resourcetypes == null) {
			resourcetypes = create(null);
			getContext().getResourceTypesResource().getContents().add(resourcetypes);
		}
		return resourcetypes;
	}
	
	@Override
	public List<? extends ModelTemplate<? super ResourceTypeRepository, ?>> getChildCommands() {
		return new ArrayList<>(processingResources.values());
	}

	@Override
	public boolean matches(ResourceTypeRepository object) {
		return true;
	}

	@Override
	protected ResourceTypeRepository create(ResourceTypeRepository parent) {
		return ResourcetypeFactory.eINSTANCE.createResourceTypeRepository();
	}
	
	public ProcessingResourceTypeTemplate defineProcessingResource(String name) {
		ProcessingResourceTypeTemplate template = processingResources.get(name);
		if (template == null) {
			template = new ProcessingResourceTypeTemplate(name);
			processingResources.put(name, template);
		}
		return template;
	}

}
